Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang
Class Process

    java.lang.Object
      |
      +--java.lang.Process

public abstract class Process
extends Object

The `Runtime.exec` methods create a native process and return an instance of a subclass of `Process` that can be used to control the process and obtain information about it. The class `Process` provides methods for performing input from the process, performing output to the process, waiting for the process to complete, checking the exit status of the process, and destroying (killing) the process.

The `Runtime.exec` methods may not work well for special processes on certain native platforms, such as native windowing processes, daemon processes, Win16/DOS processes on Win32, or shell scripts. The created subprocess does not have its own terminal or console. All its standard io (i.e. stdin, stdout, stderr) operations will be redirected to the parent process through three streams (`Process.getOutputStream()`, `Process.getInputStream()`, `Process.getErrorStream()`). The parent process uses these streams to feed input to and get output from the subprocess. Because some native platforms only provide limited buffer size for standard input and output streams, failure to promptly write the input stream or read the output stream of the subprocess may cause the subprocess to block, and even deadlock.

The subprocess is not killed when there are no more references to the `Process` object, but rather the subprocess continues executing asynchronously.

There is no requirement that a process represented by a `Process` object execute asynchronously or concurrently with respect to the Java process that owns the `Process` object.

Since:
  JDK1.0
See Also:
  `Runtime.exec(java.lang.String)`, `Runtime.exec(java.lang.String, java.lang.String[])`, `Runtime.exec(java.lang.String[])`, `Runtime.exec(java.lang.String[], java.lang.String[])`

Constructor Summary
`Process()`

Method Summary
`abstract void` | `destroy()` Kills the subprocess.
`abstract int` | `exitValue()` Returns the exit value for the subprocess.
`abstract InputStream` | `getErrorStream()` Gets the error stream of the subprocess.
`abstract InputStream` | `getInputStream()` Gets the input stream of the subprocess.
`abstract OutputStream` | `getOutputStream()` Gets the output stream of the subprocess.
`abstract int` | `waitFor()` causes the current thread to wait, if necessary, until the process represented by this `Process` object has terminated.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Process

    public Process()

Method Detail

### getOutputStream

    public abstract OutputStream getOutputStream()

  Gets the output stream of the subprocess. Output to the stream is piped into the standard input stream of the process represented by this `Process` object.

  Implementation note: It is a good idea for the output stream to be buffered.

  Returns:
    the output stream connected to the normal input of the subprocess.

### getInputStream

    public abstract InputStream getInputStream()

  Gets the input stream of the subprocess. The stream obtains data piped from the standard output stream of the process represented by this `Process` object.

  Implementation note: It is a good idea for the input stream to be buffered.

  Returns:
    the input stream connected to the normal output of the subprocess.

### getErrorStream

    public abstract InputStream getErrorStream()

  Gets the error stream of the subprocess. The stream obtains data piped from the error output stream of the process represented by this `Process` object.

  Implementation note: It is a good idea for the input stream to be buffered.

  Returns:
    the input stream connected to the error stream of the subprocess.

### waitFor

    public abstract int waitFor()
                         throws InterruptedException

  causes the current thread to wait, if necessary, until the process represented by this `Process` object has terminated. This method returns immediately if the subprocess has already terminated. If the subprocess has not yet terminated, the calling thread will be blocked until the subprocess exits.
  Returns:
    the exit value of the process. By convention, `0` indicates normal termination.
  Throws:
    `InterruptedException` - if the current thread is `interrupted` by another thread while it is waiting, then the wait is ended and an `InterruptedException` is thrown.

### exitValue

    public abstract int exitValue()

  Returns the exit value for the subprocess.
  Returns:
    the exit value of the subprocess represented by this `Process` object. by convention, the value `0` indicates normal termination.
  Throws:
    `IllegalThreadStateException` - if the subprocess represented by this `Process` object has not yet terminated.

### destroy

    public abstract void destroy()

  Kills the subprocess. The subprocess represented by this `Process` object is forcibly terminated.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Java is a trademark or registred trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2000 Sun Microsystems, Inc. 901 San Antonio Road,
Palo, Alto, California, 94303, U.S.A All Rights Reserved. < /font >